﻿using Infragistics.Controls.Charts;
using KB7745_SampleApp1.Model;
using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Data;


namespace KB7745_SampleApp1
{
    internal class CrosshairPointToNearestDataPoint : IMultiValueConverter
    {
        public object Convert(object[] values, Type targetType, object parameter, CultureInfo culture)
        {
            if (values == null || values.Length != 2) return Binding.DoNothing;
            if (values[0] == null || values[1] == null) return Binding.DoNothing;

            if (values[0].GetType() != typeof(Point)) return Binding.DoNothing;
            Point point = (Point)values[0];
            if (Double.IsNaN(point.X) || Double.IsNaN(point.Y))
            {
                return Binding.DoNothing;
            }

            Series series = values[1] as Series;
            if (series == null) return Binding.DoNothing;

            // CrosshairPointから近傍データ点を取得する。
            SampleCategoryDataItem dataPoint = series.GetItem(point) as SampleCategoryDataItem;
            if (dataPoint != null)
            {
                return String.Format("(X, Y)=({0}, {1})", dataPoint.Category, dataPoint.Value);
            }
            return Binding.DoNothing;
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
